<?php

declare(strict_types=1);

use Rector\Config\RectorConfig;
use Rector\Php74\Rector\Closure\ClosureToArrowFunctionRector;
use Rector\Php81\Rector\ClassConst\FinalizePublicClassConstantRector;
use Rector\Php81\Rector\Property\ReadOnlyPropertyRector;
use Rector\Set\ValueObject\SetList;

return static function (RectorConfig $rectorConfig): void {
    // get parameters
    $rectorConfig->paths([
            __DIR__ . '/src',
            __DIR__ . '/tests/Application/src',
        ]
    );

    // Define what rule sets will be applied
    $rectorConfig->import(SetList::PHP_81);

    $rectorConfig->importNames();
    $rectorConfig->importShortClasses();

    $rectorConfig->singleton(ClosureToArrowFunctionRector::class);
    $rectorConfig->singleton(ReadOnlyPropertyRector::class);
    $rectorConfig->singleton(FinalizePublicClassConstantRector::class);
};