<?php

declare(strict_types=1);

namespace Dedi\SyliusSogenactifPlugin\Payum\Sogenactif\Action;

use Payum\Core\Action\ActionInterface;
use Payum\Core\Exception\RequestNotSupportedException;
use Payum\Core\Request\BaseGetStatus;
use Sylius\Component\Core\Model\PaymentInterface as SyliusPaymentInterface;

final class Status implements ActionInterface
{
    public function execute($request): void
    {
        RequestNotSupportedException::assertSupports($this, $request);

        /** @var SyliusPaymentInterface $payment */
        $payment = $request->getFirstModel();

        $details = $payment->getDetails();

        // Handle other status
        // @TODO handle 05 : failed
        if (count($details) > 0 &&
            array_key_exists('all_normalized_infos', $details) &&
            array_key_exists('responseCode', $details['all_normalized_infos']) &&
            '00' === $details['all_normalized_infos']['responseCode']
        ) {
            $request->markCaptured();

            return;
        }
        $request->markFailed();

        return;
    }

    public function supports($request): bool
    {
        return
            $request instanceof BaseGetStatus &&
            $request->getFirstModel() instanceof SyliusPaymentInterface
        ;
    }
}
