<?php

declare(strict_types=1);

namespace Dedi\SyliusSogenactifPlugin\Payum\Sogenactif;

final class Api implements ApiInterface
{
    public function __construct(
        private readonly string $secretKey = '',
        private readonly string $merchantId = '',
        private readonly int $keyVersion = 1,
    ) {
    }

    public function getSecretKey(): string
    {
        return $this->secretKey;
    }

    public function getKeyVersion(): int
    {
        return $this->keyVersion;
    }

    public function getMerchantId(): string
    {
        return $this->merchantId;
    }
}
